QGIS Application - Bug report #13670
DBManager selects wrong field as key when loading view from PostGIS
2015-10-25 05:58 AM - Sebastian Dietrich

Status: Closed

Priority: Normal

Assignee:

Category: DB Manager

Affected QGIS version:master Regression?: No
Operating System: Easy fix?: No

Pull Request or Patch supplied: Resolution: end of life
Crashes QGIS or corrupls data: Copied to github as #: 21704
Description

When loading a view with DBManager the first numeric column is selected as the key. If the data in that column is not unique the
addition of the layer fails.

If it is unique in the first place but later becomes non-unique, the layer fails to load correctly when opening the project or layer definition
file.

Related issues:
Related to QGIS Application - Bug report # 13341: DBManager doesn't import vi... Closed 2015-09-11

History

#1 - 2015-10-25 06:03 AM - Sebastian Dietrich
To reproduce:

- Create a view with the first numeric column not being unique:
CREATE OR REPLACE VIEW "TestViewFail" AS
SELECT

1 AS "nonID",
generate_series(1, 2) AS "ID"

- Create the same view with the columns swapped:

CREATE OR REPLACE VIEW "TestViewPass" AS

SELECT

generate_series(1, 2) AS "ID",
1 AS "nonID"

- Try to add both views from DBManager. Note that the addition of the first view fails while the addition of the second one succeeds.

#2 - 2015-10-25 06:12 AM - Sebastian Dietrich
- Assignee set to Giuseppe Sucameli

This is related to #13341, where DBManager fails to load a view with a non-numeric primary key.

I think the best solution - for both tickets - would be to have the user select the columns that make up the primary key for the view. Pretty much the same

way it is already done when adding a query from DBManager or when adding a view from the Add PostGIS layer dialog.
#3 - 2017-05-01 01:06 AM - Giovanni Manghi
- Easy fix? set to No

- Regression? set to No

#4 - 2018-09-24 11:17 AM - Jiirgen Fischer
- Assignee deleted (Giuseppe Sucameli)
- Description updated

#5 - 2019-03-09 04:09 PM - Giovanni Manghi

- Resolution set to end of life

- Status changed from Open to Closed

End of life notice: QGIS 2.18 LTR

Source:
http://blog.qgis.org/2019/03/09/end-of-life-notice-qgis-2-18-ltr/

2024-04-20 22


http://blog.qgis.org/2019/03/09/end-of-life-notice-qgis-2-18-ltr/

